/* AMX Mod script.
*
* (c) 2003, tcquest78
* This file is provided as is (no warranties).
*
* Provides help for admin commands with amx_help command
*/

#include <amxmod>

#define HELPAMOUNT 10 // Number of commands per page

public plugin_init() {
  register_plugin("Admin Help","0.9.4","tcquest78") 
  register_concmd("amx_help","cmdHelp",0,"- displays this help")
  setHelp(0)
}

public cmdHelp(id,level,cid){
  new arg1[8]
  new flags = get_user_flags(id)
  new start = read_argv(1,arg1,7) ? strtonum(arg1) : 1
  if (--start < 0) start = 0
  new clcmdsnum = get_concmdsnum(flags,id)
  if (start >= clcmdsnum) start = clcmdsnum - 1
  if (flags){
    new sflags[32]
    get_flags(flags,sflags,31)
    console_print(id,"Your access is: %s. You have %simmunity.^n",sflags, (flags&ADMIN_IMMUNITY)?"":"no " ) 
  }
  else
    console_print(id,"You are not logged as admin or user with privileges.^n")
  console_print(id,"----- AMX Help: Commands -----")
  new info[128], cmd[32], eflags
  new end = start + HELPAMOUNT
  if (end > clcmdsnum) end = clcmdsnum
  for (new i = start; i < end; i++){
    get_concmd(i,cmd,31,eflags,info,127,flags,id)
    console_print(id,"%3d: %s %s",i+1,cmd,info)
  }
  if (end < clcmdsnum) {
     console_print(id,"----- Entries %i - %i of %i -----",start+1,end,clcmdsnum)
     console_print(id,"----- Use 'amx_help %i' for more -----",end+1)
  } else { 
     console_print(id,"----- Entries %i - %i of %i -----",start+1,clcmdsnum,clcmdsnum)
     console_print(id,"----- Use 'amx_help 1' for begin -----")
  }
  return PLUGIN_HANDLED 
}

public dispInfo(param[]){
  new id = param[0]
  if (id)
    client_print(id,print_chat,"* Type 'amx_help' in the console to see available commands")
  else
    server_print("Type 'amx_help' in the console to see available commands")
  new nextmap[32]
  get_cvar_string("amx_nextmap",nextmap,31)
  if (get_cvar_float("mp_timelimit")){
    new timeleft = get_timeleft()
    if (timeleft > 0){
      if (id)
        client_print(id,print_chat,"* Time remaining: %d:%02d min. The next map will be %s",
          timeleft / 60, timeleft % 60,nextmap)
      else
        server_print("Time remaining: %d:%02d min. The next map will be %s",
          timeleft / 60, timeleft % 60,nextmap)     
    }
  }
  else{
    if (id)
      client_print(id,print_chat,"* There is no time limit. The next map will be %s",nextmap)
    else
      server_print("There is no time limit. The next map will be %s",nextmap)
  }
}

setHelp(id){
  new param[1]
  param[0] = id
  set_task(15.0,"dispInfo",0,param,1)
}

public client_putinserver(id)
  setHelp(id)